<?php
////////////////////////////////////////////////////////
// Function:         dump
// Inspired from:     PHP.net Contributions
// Description: Helps with php debugging

function dump($var, $info = FALSE)
{
    $scope = false;
    $prefix = 'unique';
    $suffix = 'value';
  
    if($scope) $vals = $scope;
    else $vals = $GLOBALS;

    $old = $var;
    $var = $new = $prefix.rand().$suffix; $vname = FALSE;
    foreach($vals as $key => $val) if($val === $new) $vname = $key;
    $var = $old;
	$link = "<a href='#' style='float:right' onclick=\"$(this).parent('pre').hide()\">X</a>";
    echo "<pre style='white-space:pre-wrap;margin: 10px; display: block; background: white; color: black; font-family: monospace; border: 1px solid #cccccc; padding: 10px;'>$link";
	if($info != FALSE) echo "<b style='color: red;'>$info:</b><br>";
    do_dump($var, '$'.$vname);
    echo "</pre>";
}

////////////////////////////////////////////////////////
// Function:         do_dump
// Inspired from:     PHP.net Contributions
// Description: Better GI than print_r or var_dump

function do_dump(&$var, $var_name = NULL, $indent = NULL, $reference = NULL)
{
    $do_dump_indent = "<span style='color:#eeeeee;'>|</span> &nbsp; ";
    $reference = $reference.$var_name;
    $keyvar = 'the_do_dump_recursion_protection_scheme'; $keyname = 'referenced_object_name';

    if (is_array($var) && isset($var[$keyvar]))
    {
        $real_var = &$var[$keyvar];
        $real_name = &$var[$keyname];
        $type = ucfirst(gettype($real_var));
        echo "$indent$var_name <span style='color:#a2a2a2'>$type</span> = <span style='color:#e87800;'>&amp;$real_name</span><br>";
    }
    else
    {
        $var = array($keyvar => $var, $keyname => $reference);
        $avar = &$var[$keyvar];
    
        $type = ucfirst(gettype($avar));
        if($type == "String") $type_color = "<span style='color:darkorange'>";
        elseif($type == "Integer") $type_color = "<span style='color:red'>";
        elseif($type == "Double"){ $type_color = "<span style='color:#0099c5'>"; $type = "Float"; }
        elseif($type == "Boolean") $type_color = "<span style='color:#92008d'>";
        elseif($type == "NULL") $type_color = "<span style='color:blue'>";
    
        if(is_array($avar))
        {
            $count = count($avar);
            echo "$indent$var_name => <span style='color:#a2a2a2'>$type ($count)</span><br>$indent(<br>";
            $keys = array_keys($avar);
            foreach($keys as $name)
            {
                $value = &$avar[$name];
                do_dump($value, "$name", $indent.$do_dump_indent, $reference);
            }
            echo "$indent)<br>";
        }
        elseif(is_object($avar))
        {
			$cls = get_class ($avar);
            echo "$indent$var_name <span style='color:darkblue'>$cls</span><br>$indent(<br>";
            foreach($avar as $name=>$value) do_dump($value, "$name", $indent.$do_dump_indent, $reference);
            echo "$indent)<br>";
        }
		//<span style='color:#a2a2a2'>$type(".strlen($avar).")</span>
        elseif(is_int($avar))    echo "$indent$var_name = $type_color$avar</span><br>";
        elseif(is_string($avar)) echo "$indent$var_name = $type_color" . htmlspecialchars($avar) . "</span><br>";
        elseif(is_float($avar))  echo "$indent$var_name = $type_color$avar</span><br>";
        elseif(is_bool($avar))   echo "$indent$var_name = $type_color".($avar == 1 ? "TRUE":"FALSE")."</span><br>";
        elseif(is_null($avar))   echo "$indent$var_name = {$type_color}NULL</span><br>";
        else echo "$indent$var_name = <span style='color:#a2a2a2'>$type(".strlen($avar).")</span> $avar<br>";

        $var = $var[$keyvar];
    }
}


function print_b($subject){

//echo str_replace("=>","&#8658;",str_replace("Array","<font color=\"red\"><b>Array</b></font>",str_replace(" "," ",print_r($subject,true))));

$a[] = "/=>/"; $b[] = "&#8658;";
$a[] = "/Array/"; $b[] = "<font color=\"red\"><b>Array</b></font>";
$a[] = "/(\s*)\[(.*?)\]/"; $b[] = "$1<font color=\"green\"><b>$2</b></font>";

echo preg_replace($a,$b,print_r($subject,true));

}

function print_a($var){
	echo "<pre style=\"background:#FEFEFE;border:1px solid #AAA;padding:10px; margin:10px;font-family:monospace\">";
	
	
	if ($var)
		print_b($var);
	else
		print_b($var);
	echo "</pre>";
}


function do_print(&$var, $name, $prefix = null, $reference = null){
	if (strlen((string)$prefix) > 10) return '';
    $do_dump_indent = "<span style='color:#eeeeee;'>|</span> &nbsp; ";
    $reference = $reference.$var_name;
    $keyvar = 'the_do_dump_recursion_protection_scheme'; $keyname = 'referenced_object_name';

    if (is_array($var) && isset($var[$keyvar]))
    {
        $real_var = &$var[$keyvar];
        $real_name = &$var[$keyname];
        $type = ucfirst(gettype($real_var));
        echo "$indent$var_name <span style='color:#a2a2a2'>$type</span> = <span style='color:#e87800;'>&amp;$real_name</span><br>";
    }
    else
    {
        $var = array($keyvar => $var, $keyname => $reference);
        $avar = &$var[$keyvar];
    
        $type = ucfirst(gettype($avar));
        if($type == "String") $type_color = "<span style='color:darkorange'>";
        elseif($type == "Integer") $type_color = "<span style='color:red'>";
        elseif($type == "Double"){ $type_color = "<span style='color:#0099c5'>"; $type = "Float"; }
        elseif($type == "Boolean") $type_color = "<span style='color:#92008d'>";
        elseif($type == "NULL") $type_color = "<span style='color:blue'>";
    
        if(is_array($avar))
        {
            $count = count($avar);
            echo "$indent$var_name => <span style='color:#a2a2a2'>$type ($count)</span><br>$indent(<br>";
            $keys = array_keys($avar);
            foreach($keys as $name)
            {
                $value = &$avar[$name];
                do_dump($value, "$name", $indent.$do_dump_indent, $reference);
            }
            echo "$indent)<br>";
        }
        elseif(is_object($avar))
        {
			$cls = get_class ($avar);
            echo "$indent$var_name <span style='color:darkblue'>$cls</span><br>$indent(<br>";
            foreach($avar as $name=>$value) do_dump($value, "$name", $indent.$do_dump_indent, $reference);
            echo "$indent)<br>";
        }
		//<span style='color:#a2a2a2'>$type(".strlen($avar).")</span>
        elseif(is_int($avar))    echo "$indent$var_name = $type_color$avar</span><br>";
        elseif(is_string($avar)) echo "$indent$var_name = $type_color" . htmlentities($avar) . "</span><br>";
        elseif(is_float($avar))  echo "$indent$var_name = $type_color$avar</span><br>";
        elseif(is_bool($avar))   echo "$indent$var_name = $type_color".($avar == 1 ? "TRUE":"FALSE")."</span><br>";
        elseif(is_null($avar))   echo "$indent$var_name = {$type_color}NULL</span><br>";
        else echo "$indent$var_name = <span style='color:#a2a2a2'>$type(".strlen($avar).")</span> $avar<br>";

        $var = $var[$keyvar];
    }
}

function print_a_($var){



	echo "<pre style=\"background:#FEFEFE;border:1px solid #AAA;padding:10px; margin:10px;font-family:monospace\">";
	
	//debug_print_backtrace();

	/*
	foreach($var as $elem)
	{
		echo "$var\n";
	}*/
	
	/*if ($var)
		do_print($var, '$');
	else
		do_print($var, '$');
	*/
	echo "</pre>";
}


?>